//                                                        
//   Programa elaborado por Genaro Juarez Martinez        
//   e-mail: genaro@enigma.red.cinvestav.mx               
//               genarojm@correo.unam.mx                             
//   Area: Automatas Celulares                            
//   CINVESTAV IPN                                        
//                                                        

#import "control.h"
int matriz_regla1[4][8];

@implementation control

/*Manda el tag y la posicion de la celula*/
-(void)mandarPosicionTag:(id)sender
{
    int renglon;
    int columna;
    int identificador;
    int estado;
    /*Captura el tag de la celula*/
    identificador=[[sender selectedCell] tag];
    /*Captura el renglon y la columna de la matriz*/
    renglon=[sender selectedRow];
    columna=[sender selectedColumn];
    /*Captura el estado*/
    estado=[[[vista_matriz cellAtRow:renglon column:columna] title] intValue];
    /*Le manda la posicion, el estado y el identificadora a la clase matriz*/
    [vista_matriz capturarPosicion:renglon:columna:identificador:estado];
}

/*Boton paso a paso*/
-(void)evolPaso:(id)sender
{
    int i,j;
    /*Llamar a pasoaPaso de la clase life2dM*/
    for(i=0;i<4;i++)
        for(j=0;j<8;j++)
            matriz_regla1[i][j]=[vista_matriz traerVecindad:i:j];
    /*Traer la regla de control*/
    for(i=0;i<4;i++)
        for(j=0;j<8;j++)
            [vista_view establecerRegla:i:j:matriz_regla1[i][j]];
    /*Ejecuta el metodo paso a paso de la clase life2dM*/
    [vista_view pasoaPaso:sender];
}

/*Boton evolucion*/
-(void)evol:(id)sender
{
    int i,j;
    /*Llamar a pasoaPaso de la clase life2dM*/
    for(i=0;i<4;i++)
        for(j=0;j<8;j++)
            matriz_regla1[i][j]=[vista_matriz traerVecindad:i:j];
    /*Traer la regla de control*/
    for(i=0;i<4;i++)
        for(j=0;j<8;j++)
            [vista_view establecerRegla:i:j:matriz_regla1[i][j]];
    /*Ejecuta el metodo paso a paso de la clase life2dM*/
    [vista_view toggleRun:sender];
}

/*Limpiar regla*/
-(void)limpiarRegla:(id)sender
{
    int i,j;
    for(i=0;i<4;i++)
        for(j=0;j<8;j++)
            matriz_regla1[i][j]=0;
    [vista_matriz limpiarArreglo:self];
}

/*Regla aleatoria*/
-(void)reglaAleatoria:(id)sender
{
    int i,j;
    float y,flag=0.4;
    time_t segundos;
    time(&segundos);
    srand((unsigned)(segundos % 65536));
    for(i=0;i<4;i++)
    {
        for(j=0;j<8;j++)
        {
            y = rand()/pow(2,31);
            if(y>=flag)
                matriz_regla1[i][j]=0;
            else
                matriz_regla1[i][j]=1;
            [vista_matriz arregloAleatoria:i:j:matriz_regla1[i][j]];
        }
    }
}

@end
