//                                                        
//   Programa elaborado por Genaro Juarez Martinez        
//   e-mail: genaro@enigma.red.cinvestav.mx               
//               genarojm@correo.unam.mx                             
//   Area: Automatas Celulares                            
//   CINVESTAV IPN                                        
//                                                        

#import <AppKit/AppKit.h>
#import "control.h"

@interface life2dvn : NSView
{
    /*Cuenta el numero de celulas vivas por cada generacion*/
    id cellvivas;
    /*Cuenta el numero de iteraciones calculadas*/
    id generaciones;
    /*Determina la cantidad de celulas vivas al inicio*/
    id densidad;
    /*Captura coordenada directa del view*/
    id posicionx;
    id posiciony;
    NSTimer *linesTimer;
    BOOL running;
}

/*Inicializa la grafica*/
- initWithFrame:(NSRect)rects;

/*Dibuja la grafica*/
-(void)drawRect:(NSRect)rects;

/*Dibuja una celula*/
-(void)dibujaPunto:(int)x:(int)y:(float)rojo:(float)verde:(float)azul;

/*Dibuja una linea*/
-(void)dibujarLinea:(int)x1:(int)y1:(int)x2:(int)y2:(float)rojo:(float)verde:(float)azul;

/*Dibuja la malla*/
-(void)dibujaMalla:(id)sender;

/*Configuracion aleatoria*/
-(void)configuracionAleatoria:(id)sender;

/*Configuracion aleatoria*/
-(void)dibujaConfiguracion:(id)sender;

/*Traer regla de control*/
-(void)establecerRegla:(int)renglon:(int)columna:(int)estado;

/*Evolucion paso a paso*/
-(void)pasoaPaso:(id)sender;

/*Utiliza regla 110 para llenar el plano inicial*/
-(void)regla110:(id)sender;

/*Limpia la vista*/
-(void)limpiarVista:(id)sender;

/*Limpia todo*/
-(void)limpiarTodo:(id)sender;

/*Activa el mouse con mouse down*/
-(void)mouseDown:(NSEvent *)event;

- (void)dealloc;
- (void)toggleRun:sender;
- (void)animate:(NSTimer *)timer;

@end
