//                                                        
//   Programa elaborado por Genaro Juarez Martinez        
//   e-mail: genaro@enigma.red.cinvestav.mx               
//               genarojm@correo.unam.mx                             
//   Area: Automatas Celulares                            
//   CINVESTAV IPN                                        
//                                                        

#import "matriz.h"

/*Matriz que guarda la regla de evolucion*/
int matriz_regla[4][8];

@implementation matriz

/*Inicializa la matriz de botones*/
- initWithFrame:(NSRect)rects
{
    int i,j;
    [super initWithFrame:rects];
    /*Inicializa la matriz_regla en ceros*/
    for(i=0;i<4;i++)
        for(j=0;j<8;j++)
            matriz_regla[i][j]=0;
    return self;
}

/*Captura la posicion de la celula y el tag*/
-(void)capturarPosicion:(int)renglon:(int)columna:(int)identificador:(int)estado
{
    /*Determina el estado en la posicion capturada*/
    if(estado==0)
    {
        [[self cellAtRow:renglon column:columna] setTitle: [NSString stringWithFormat:@"%d",1]];
        /*Almacenar valores en la matriz original*/
        matriz_regla[renglon][columna]=1;
    }
    if(estado==1)
    {
        [[self cellAtRow:renglon column:columna] setTitle: [NSString stringWithFormat:@"%d",0]];
        /*Almacenar valores en la matriz original*/
        matriz_regla[renglon][columna]=0;
    }
}

/*Determina la vecindad en base el tag de la celula que va a evolucionar*/
-(int)traerVecindad:(int)renglon:(int)columna
{
    /*Le mando el arreglo matriz_regla a control*/
    return matriz_regla[renglon][columna];
}

/*Limpia el arreglo*/
-(void)limpiarArreglo:(id)sender
{
    int i,j;
    for(i=0;i<4;i++)
    {
        for(j=0;j<8;j++)
        {
            [[self cellAtRow:i column:j] setTitle: [NSString stringWithFormat:@"%d",0]];
            matriz_regla[i][j]=0;
        }
    }
}

/*Arreglo aleatorio*/
-(void)arregloAleatoria:(int)renglon:(int)columna:(int)estado
{
    matriz_regla[renglon][columna]=estado;
    if(matriz_regla[renglon][columna]==0)
        [[self cellAtRow:renglon column:columna] setTitle: [NSString stringWithFormat:@"%d",0]];
    else
        [[self cellAtRow:renglon column:columna] setTitle: [NSString stringWithFormat:@"%d",1]];
}

@end
